package hr.fer.zemris.diplomskiseminar.mmo.datamodel;

import java.util.ArrayList;
import java.util.List;

public class Front {

	public List<DecimalArraySolution> solutions;
	
	public Front() {
		solutions = new ArrayList<>();
	}
	
	public void add(DecimalArraySolution solution){
		solutions.add(solution);
	}
	
	
	public double fitnessSharing(double dummyFitness, double sigmaShare, int n){
		double[] mins = new double[n];
		double[] maxs = new double[n];
		for(int i=0; i<solutions.size(); i++){
			double[] dimensions = solutions.get(i).getVector();
			if(i==0){
				for(int j=0; j<dimensions.length; j++){
					mins[j] = dimensions[j];
					maxs[j] = dimensions[j];
				}
			}
			else{
				for(int j=0; j<dimensions.length; j++){
					if(dimensions[j] < mins[j]){
						mins[j] = dimensions[j];
					}
					if(dimensions[j] > maxs[j]){
						maxs[j] = dimensions[j];
					}
				}
			}
		}
		double nicheCount;
		double distance;
		double minFitness = 0;
		for(int i=0; i<solutions.size(); i++){
			nicheCount = 1.0;
			for(int j=0; j<solutions.size(); j++){
				if(i != j){
					distance = solutions.get(i).getDistance(solutions.get(j), mins, maxs);
					nicheCount += sh(distance, sigmaShare);
				}				
			}
			double fitness = dummyFitness/nicheCount;
			solutions.get(i).TOTAL_FITNESS = fitness;
			if(i==0){
				minFitness = fitness;
			}
			else if(fitness < minFitness){
				minFitness = fitness;
			}
		}
		
		
		return minFitness;
	}
	
	private double sh(double distance, double sigmaShare){
		
		if(distance < sigmaShare){
			return 1 - Math.pow(distance/sigmaShare, 2);
		}
		return 0.0;
	}
}
