package hr.fer.zemris.diplomskiseminar.mmo.datamodel;

import hr.fer.zemris.diplomskiseminar.mmo.problems.IMMOProblem;

import java.util.ArrayList;
import java.util.List;

public class Population {
	
	public int solutionsWithFront;
	private List<DecimalArraySolution> solutions;
	private int POP_SIZE;
	private List<DecimalArraySolution> nondominated;
	private int M;
	private int n;
	private double mins;
	private double maxs;
	
	public Population(int POP_SIZE, int M, double mins, double maxs, int n) {
		super();
		this.POP_SIZE = POP_SIZE;
		this.M = M;
		solutions = new ArrayList<>(POP_SIZE);
		this.mins = mins;
		this.maxs = maxs;
		this.n = n;
	}

	public void initializePopulation(){
		solutionsWithFront = 0;
		DecimalArraySolution tmp;
		for(int i=0; i<POP_SIZE; i++){
			tmp = new DecimalArraySolution(M, mins, maxs, n);
			tmp.randomize(Parameters.rand);
			solutions.add(tmp);
		}
	}

	public List<DecimalArraySolution> getSolutions() {
		return solutions;
	}

	public void setSolutions(List<DecimalArraySolution> solutions) {
		this.solutions = solutions;
	}
	
	public boolean isClassified(){
		return solutionsWithFront < POP_SIZE ? false : true;
	}
	
	public void addNondominated(DecimalArraySolution s){
		nondominated.add(s);
	}
	
	public void evaluatePopulation(IMMOProblem problem){
		DecimalArraySolution solution;
		for(int i=0; i<solutions.size(); i++){
			solution = solutions.get(i);
//			if(solution.getValues() == null){
//				solution.setValues(new double[M]);
//			}
			solution.setValue(problem);
		}
	}
	
	
}
