package hr.fer.zemris.diplomskiseminar.mmo.gui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Dimension;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.WindowConstants;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.xy.XYDataset;
import org.jfree.ui.RefineryUtilities;

public class Chart extends JFrame {

	private static final long serialVersionUID = 1L;
	private XYDataset myDataset;

	public Chart(String title, XYDataset dataset) {
		super(title);
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);	
		myDataset = dataset;
		JPanel panel = createPanel();
		panel.setPreferredSize(new Dimension(500, 270));
		this.getContentPane().add(panel);

	}

	private JPanel createPanel() {
		JFreeChart localJFreeChart = createChart(myDataset);
		ChartPanel localChartPanel = new ChartPanel(localJFreeChart);
		localChartPanel.setMouseWheelEnabled(true);
		return localChartPanel;
	}

	private JFreeChart createChart(XYDataset myDataset) {
		JFreeChart localJFreeChart = ChartFactory.createScatterPlot("Rezultat",
				"f1", "f2", myDataset, PlotOrientation.VERTICAL, true, true,
				false);
		XYPlot localXYPlot = (XYPlot) localJFreeChart.getPlot();
		localXYPlot.setNoDataMessage("NO DATA");
		localXYPlot.setDomainPannable(true);
		localXYPlot.setRangePannable(true);
		localXYPlot.setDomainZeroBaselineVisible(true);
		localXYPlot.setRangeZeroBaselineVisible(true);
		localXYPlot.setDomainGridlineStroke(new BasicStroke(0.0F));
		localXYPlot.setDomainMinorGridlineStroke(new BasicStroke(0.0F));
		localXYPlot.setDomainGridlinePaint(Color.blue);
		localXYPlot.setRangeGridlineStroke(new BasicStroke(0.0F));
		localXYPlot.setRangeMinorGridlineStroke(new BasicStroke(0.0F));
		localXYPlot.setRangeGridlinePaint(Color.blue);
		localXYPlot.setDomainMinorGridlinesVisible(true);
		localXYPlot.setRangeMinorGridlinesVisible(true);
		XYLineAndShapeRenderer localXYLineAndShapeRenderer = (XYLineAndShapeRenderer) localXYPlot
				.getRenderer();
		localXYLineAndShapeRenderer.setSeriesOutlinePaint(0, Color.black);
		localXYLineAndShapeRenderer.setUseOutlinePaint(true);
		NumberAxis localNumberAxis1 = (NumberAxis) localXYPlot.getDomainAxis();
		localNumberAxis1.setAutoRangeIncludesZero(false);
		localNumberAxis1.setTickMarkInsideLength(2.0F);
		localNumberAxis1.setTickMarkOutsideLength(2.0F);
		localNumberAxis1.setMinorTickCount(2);
		localNumberAxis1.setMinorTickMarksVisible(true);
		NumberAxis localNumberAxis2 = (NumberAxis) localXYPlot.getRangeAxis();
		localNumberAxis2.setTickMarkInsideLength(2.0F);
		localNumberAxis2.setTickMarkOutsideLength(2.0F);
		localNumberAxis2.setMinorTickCount(2);
		localNumberAxis2.setMinorTickMarksVisible(true);
		return localJFreeChart;
	}

	public static void showChart(XYDataset myDataset) {

		Chart chart = new Chart("Prikaz rezultata", myDataset);
		chart.pack();
		RefineryUtilities.centerFrameOnScreen(chart);
		chart.setVisible(true);
	}

}
