package hr.fer.zemris.diplomskiseminar.mmo.problems;

public class MMOProblemFON implements IMMOProblem{

	private IFunction f1 = new IFunction() {
		
		@Override
		public double getFunctionValue(double[] vectorPoint) {
			
			double sum = 0;
			double konst = 1.0/Math.sqrt(3.0);
			
			for(int i=0; i<3; i++){
				sum += Math.pow(vectorPoint[i] - konst, 2);
			}
			
			return 1.0 - Math.exp(-sum);
		}
	};
	
	private IFunction f2 = new IFunction() {
		
		@Override
		public double getFunctionValue(double[] vectorPoint) {
			
			double sum = 0;
			double konst = 1.0/Math.sqrt(3.0);
			
			for(int i=0; i<3; i++){
				sum += Math.pow(vectorPoint[i] + konst, 2);
			}
			
			return 1.0 - Math.exp(-sum);
		}
	};
	
	@Override
	public IFunction getObjective(int i) {
		
		if(i==0){
			return f1;
		}
		if(i==1){
			return f2;
		}
		return null;
	}

	@Override
	public double getMinBound() {
		
		return -4.0;
	}

	@Override
	public double getMaxBound() {
		
		return 4.0;
	}

	@Override
	public int objectivesNumber() {
		
		return 2;
	}

	@Override
	public int getDimensionNumber() {
		
		return 3;
	}

}
