package hr.fer.zemris.diplomskiseminar.mmo.problems;

public class MMOProblemKUR implements IMMOProblem{

	IFunction f1 = new IFunction() {
		
		@Override
		public double getFunctionValue(double[] vectorPoint) {
			double sum = 0;
			for(int i=0; i<2; i++){
				sum += -10*Math.exp(-0.2*Math.sqrt(vectorPoint[i]*vectorPoint[i] + vectorPoint[i+1]*vectorPoint[i+1]));
			}			
			return sum;
		}
	};
	IFunction f2 = new IFunction() {
		
		@Override
		public double getFunctionValue(double[] vectorPoint) {
			double sum = 0;
			for(int i=0; i<3; i++){
				sum += Math.pow(Math.abs(vectorPoint[i]), 0.8) + 5*Math.sin(Math.pow(vectorPoint[i], 3));
			}
			return sum;
		}
	};
	
	@Override
	public IFunction getObjective(int i) {
		
		if(i==0){
			return f1;
		}
		if(i==1){
			return f2;
		}
		return null;
	}

	@Override
	public double getMinBound() {
		
		return -5.0;
	}

	@Override
	public double getMaxBound() {
		
		return 5.0;
	}

	@Override
	public int objectivesNumber() {
		
		return 2;
	}

	@Override
	public int getDimensionNumber() {
		
		return 3;
	}

}
