package hr.fer.zemris.diplomskiseminar.mmo.problems;

public class MMOProblemPOL implements IMMOProblem{
	
	private IFunction f1 = new IFunction() {
		private double A1 = 0.5*Math.sin(1.0) - 2*Math.cos(1) + Math.sin(2.0) - 1.5*Math.cos(2.0);
		private double A2 = 1.5*Math.sin(1.0) - Math.cos(1.0) + 2*Math.sin(2.0) -0.5*Math.cos(2.0);
		
		@Override
		public double getFunctionValue(double[] vectorPoint) {
			double B1 = 0.5*Math.sin(vectorPoint[0]) - 2*Math.cos(vectorPoint[0]) + Math.sin(vectorPoint[1]) - 1.5*Math.cos(vectorPoint[1]);
			double B2 = 1.5*Math.sin(vectorPoint[0]) - Math.cos(vectorPoint[0]) + 2*Math.sin(vectorPoint[1]) - 0.5*Math.cos(vectorPoint[1]);
			return 1 + (A1 - B1)*(A1 - B1) + (A2 - B2)*(A2 - B2);
		}
	};
	
	private IFunction f2 = new IFunction() {
		
		@Override
		public double getFunctionValue(double[] vectorPoint) {
			
			return (vectorPoint[0] + 3)*(vectorPoint[0] + 3) + (vectorPoint[1] + 2)*(vectorPoint[1] + 2);
		}
	};
	
	
	@Override
	public IFunction getObjective(int i) {
		
		if(i==0){
			return f1;
		}
		if(i==1){
			return f2;
		}
		return null;
	}

	@Override
	public double getMinBound() {
		return -Math.PI;
	}

	@Override
	public double getMaxBound() {
		return Math.PI;
	}

	@Override
	public int objectivesNumber() {
		return 2;
	}

	@Override
	public int getDimensionNumber() {
		
		return 2;
	}

}
