package hr.fer.zemris.diplomskiseminar.mmo.problems;

public class MMO_ZDT1 implements IMMOProblem{

	private IFunction f1 = new IFunction() {
		
		@Override
		public double getFunctionValue(double[] vectorPoint) {
			
			return vectorPoint[0];
		}
	};
	
	private IFunction f2 = new IFunction() {
		
		@Override
		public double getFunctionValue(double[] vectorPoint) {
			double g_x = g.getFunctionValue(vectorPoint);
			return g_x*(1.0 - Math.sqrt(vectorPoint[0]/g_x));
		}
	};
	
	private IFunction g = new IFunction() {
		
		@Override
		public double getFunctionValue(double[] vectorPoint) {
			double sum = 0.0;
			for(int i=1; i<vectorPoint.length; i++){
				sum += vectorPoint[i];
			}
			return 1.0 + 9*sum/29.0;
		}
	};
	
	@Override
	public IFunction getObjective(int i) {
		if(i==0){
			return f1;
		}
		if(i==1){
			return f2;
		}
		return null;
	}

	@Override
	public double getMinBound() {
		
		return 0.0;
	}

	@Override
	public double getMaxBound() {
		
		return 1.0;
	}

	@Override
	public int objectivesNumber() {
		
		return 2;
	}

	@Override
	public int getDimensionNumber() {
		
		return 30;
	}

}
